# JavaScript MultiColumn ComboBox Control

The `JavaScript MultiColumn ComboBox` control that displays detailed information about items in a table-like structure with multiple columns. It provides comprehensive data about the selected value, offering more context than typical single-string text lists. 

<p align="center">
Trusted by the world's leading companies
  <a href="https://www.syncfusion.com">
    <img src="https://raw.githubusercontent.com/SyncfusionExamples/nuget-img/master/syncfusion/syncfusion-trusted-companies.webp" alt="Bootstrap logo">
  </a>
</p>
  
## Setup

To install the MultiColumn ComboBox and its dependent packages, use the following command.

```sh
npm install @syncfusion/ej2-multicolumn-combobox
```

## Key features

* `Data binding` - Supports data binding from JavaScript object arrays and remote data sources using adapters like OData, URLs, and Web APIs.
* `Grouping`- Allows grouping of pop-up list items to enhance the user experience by organizing related items. 
* `Filtering`- Provides advanced filtering capabilities to easily find and select items from large datasets. 
* `Sorting` - Allows sorting of items in ascending or descending order and single or multi-column sorting. 
* `Virtualization`- Supports virtualization to efficiently display large datasets by loading data on demand. 
* `Templates`- Allow customization of the appearance and layout, including header, footer and list items in the pop-up list using templates. 

## Support

Product support is available through the following mediums.

* [Support ticket](https://support.syncfusion.com/support/tickets/create) - Guaranteed Response in 24 hours | Unlimited tickets | Holiday support
* [Community forum](https://www.syncfusion.com/forums/essential-js2?utm_source=npm&utm_medium=listing&utm_campaign=javascript-multicolumn-combobox-npm)
* [GitHub issues](https://github.com/syncfusion/ej2-javascript-ui-controls/issues/new)
* [Request feature or report bug](https://www.syncfusion.com/feedback/javascript?utm_source=npm&utm_medium=listing&utm_campaign=javascript-multicolumn-combobox-npm)
* Live chat

## License and copyright

> This is a commercial product and requires a paid license for possession or use. Syncfusion’s licensed software, including this component, is subject to the terms and conditions of Syncfusion's [EULA](https://www.syncfusion.com/eula/es/). To acquire a license for 80+ [JavaScript UI controls](https://www.syncfusion.com/javascript-ui-controls), you can [purchase](https://www.syncfusion.com/sales/products) or [start a free 30-day trial](https://www.syncfusion.com/account/manage-trials/start-trials).

> A [free community license](https://www.syncfusion.com/products/communitylicense) is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue and five or fewer developers.

See [LICENSE FILE](https://github.com/syncfusion/ej2-javascript-ui-controls/blob/master/license?utm_source=npm&utm_campaign=multicolumn-combobox) for more info.

© Copyright 2025 Syncfusion<sup>®</sup> Inc. All Rights Reserved. The Syncfusion<sup>®</sup> Essential Studio<sup>®</sup> license and copyright applies to this distribution.